// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go_gapic. DO NOT EDIT.

package migration_test

import (
	"context"

	migration "cloud.google.com/go/bigquery/migration/apiv2alpha"
	"google.golang.org/api/iterator"
	migrationpb "google.golang.org/genproto/googleapis/cloud/bigquery/migration/v2alpha"
)

func ExampleNewClient() {
	ctx := context.Background()
	c, err := migration.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	// TODO: Use client.
	_ = c
}

func ExampleClient_CreateMigrationWorkflow() {
	ctx := context.Background()
	c, err := migration.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &migrationpb.CreateMigrationWorkflowRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/bigquery/migration/v2alpha#CreateMigrationWorkflowRequest.
	}
	resp, err := c.CreateMigrationWorkflow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleClient_GetMigrationWorkflow() {
	ctx := context.Background()
	c, err := migration.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &migrationpb.GetMigrationWorkflowRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/bigquery/migration/v2alpha#GetMigrationWorkflowRequest.
	}
	resp, err := c.GetMigrationWorkflow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleClient_ListMigrationWorkflows() {
	ctx := context.Background()
	c, err := migration.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &migrationpb.ListMigrationWorkflowsRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/bigquery/migration/v2alpha#ListMigrationWorkflowsRequest.
	}
	it := c.ListMigrationWorkflows(ctx, req)
	for {
		resp, err := it.Next()
		if err == iterator.Done {
			break
		}
		if err != nil {
			// TODO: Handle error.
		}
		// TODO: Use resp.
		_ = resp
	}
}

func ExampleClient_DeleteMigrationWorkflow() {
	ctx := context.Background()
	c, err := migration.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &migrationpb.DeleteMigrationWorkflowRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/bigquery/migration/v2alpha#DeleteMigrationWorkflowRequest.
	}
	err = c.DeleteMigrationWorkflow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
}

func ExampleClient_StartMigrationWorkflow() {
	ctx := context.Background()
	c, err := migration.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &migrationpb.StartMigrationWorkflowRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/bigquery/migration/v2alpha#StartMigrationWorkflowRequest.
	}
	err = c.StartMigrationWorkflow(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
}

func ExampleClient_GetMigrationSubtask() {
	ctx := context.Background()
	c, err := migration.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &migrationpb.GetMigrationSubtaskRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/bigquery/migration/v2alpha#GetMigrationSubtaskRequest.
	}
	resp, err := c.GetMigrationSubtask(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleClient_ListMigrationSubtasks() {
	ctx := context.Background()
	c, err := migration.NewClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &migrationpb.ListMigrationSubtasksRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/bigquery/migration/v2alpha#ListMigrationSubtasksRequest.
	}
	it := c.ListMigrationSubtasks(ctx, req)
	for {
		resp, err := it.Next()
		if err == iterator.Done {
			break
		}
		if err != nil {
			// TODO: Handle error.
		}
		// TODO: Use resp.
		_ = resp
	}
}
