// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go_gapic. DO NOT EDIT.

package cx_test

import (
	"context"

	cx "cloud.google.com/go/dialogflow/cx/apiv3beta1"
	"google.golang.org/api/iterator"
	cxpb "google.golang.org/genproto/googleapis/cloud/dialogflow/cx/v3beta1"
)

func ExampleNewTransitionRouteGroupsClient() {
	ctx := context.Background()
	c, err := cx.NewTransitionRouteGroupsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	// TODO: Use client.
	_ = c
}

func ExampleTransitionRouteGroupsClient_ListTransitionRouteGroups() {
	ctx := context.Background()
	c, err := cx.NewTransitionRouteGroupsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.ListTransitionRouteGroupsRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/dialogflow/cx/v3beta1#ListTransitionRouteGroupsRequest.
	}
	it := c.ListTransitionRouteGroups(ctx, req)
	for {
		resp, err := it.Next()
		if err == iterator.Done {
			break
		}
		if err != nil {
			// TODO: Handle error.
		}
		// TODO: Use resp.
		_ = resp
	}
}

func ExampleTransitionRouteGroupsClient_GetTransitionRouteGroup() {
	ctx := context.Background()
	c, err := cx.NewTransitionRouteGroupsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.GetTransitionRouteGroupRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/dialogflow/cx/v3beta1#GetTransitionRouteGroupRequest.
	}
	resp, err := c.GetTransitionRouteGroup(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleTransitionRouteGroupsClient_CreateTransitionRouteGroup() {
	ctx := context.Background()
	c, err := cx.NewTransitionRouteGroupsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.CreateTransitionRouteGroupRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/dialogflow/cx/v3beta1#CreateTransitionRouteGroupRequest.
	}
	resp, err := c.CreateTransitionRouteGroup(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleTransitionRouteGroupsClient_UpdateTransitionRouteGroup() {
	ctx := context.Background()
	c, err := cx.NewTransitionRouteGroupsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.UpdateTransitionRouteGroupRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/dialogflow/cx/v3beta1#UpdateTransitionRouteGroupRequest.
	}
	resp, err := c.UpdateTransitionRouteGroup(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleTransitionRouteGroupsClient_DeleteTransitionRouteGroup() {
	ctx := context.Background()
	c, err := cx.NewTransitionRouteGroupsClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &cxpb.DeleteTransitionRouteGroupRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/google.golang.org/genproto/googleapis/cloud/dialogflow/cx/v3beta1#DeleteTransitionRouteGroupRequest.
	}
	err = c.DeleteTransitionRouteGroup(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
}
